//+------------------------------------------------------------------+
//|                                          Ti&Pi_Laboratory.mq4    |
//|                                        Copyright  2012, FOX.RM  |
//|                                             fox.rm@mail.ru       |
//+------------------------------------------------------------------+

#property copyright "Copyright  2012, FOX.RM"
#property link      "http://www.niochem.net"

#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Red
#property  indicator_color2  Blue
#property  indicator_color3  Black
#property indicator_level1 0
#property indicator_levelcolor Gray
#property indicator_levelstyle 2

extern int Histogramm = 1;
extern double Bar_Hist = 20;
 
double MA1[],MA2[],MA3[],SMA[],VMA1[],VMA2[],VMA3[],Vol[],K1_Pl,K2_Pl,K1_Min,K2_Min;
double delta,price,old_price,col_bar,sum_tick,sum_pip,raz_bar,TP_UP[],TP_DN[],TP_UPMin[],TP_DNPl[];
double srednee_up,srednee_dn,PUP,PDN,TUP,TDN,RazP,RazT,BarRazm,p,MA11,MA22,MA33,maxpr[];
int sum_pip_bay,sum_pip_sell,i=0,limit,k=0,old_sell=0,old_bay=0;
int count_plus,count_minus,new_razm,barz,ii=0;
datetime time_Bar; 
string name_ind,text,arr;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,MA1);
   SetIndexBuffer(1,MA2);
   SetIndexBuffer(2,MA3);
   SetIndexBuffer(3,VMA1);
   SetIndexBuffer(4,VMA2);
   SetIndexBuffer(5,VMA3);
   SetIndexBuffer(6,Vol);
   SetIndexBuffer(7,SMA);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
   SetIndexEmptyValue(7,0.0); 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(0,"UP");
   SetIndexLabel(1,"DN");
  IndicatorBuffers(8);

  ArrayResize(TP_UP,Bar_Hist); ArrayInitialize(TP_UP,0);
  ArrayResize(TP_DN,Bar_Hist); ArrayInitialize(TP_DN,0);
  ArrayResize(TP_UPMin,Bar_Hist); ArrayInitialize(TP_UPMin,0);
  ArrayResize(TP_DNPl,Bar_Hist); ArrayInitialize(TP_DNPl,0);
  ArrayResize(maxpr,Bars); 


//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Ti&Pi_Tick/Pip");

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  { 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start() {  
  bool init=false;
  int counted_bars=IndicatorCounted();   
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars-1;
  
  if(limit>0) limit=0;
    
   for(i=0; i<=limit; i++) 
  {
  
    price = Close[i]/Point;    
    delta = price-old_price;
    raz_bar=(High[i]-Low[i])/Point;
      
    if(!time_Bar)time_Bar=Time[0];
    col_bar = iBarShift(NULL,0,time_Bar)-iBarShift(NULL,0,Time[i]);
    if (col_bar >= Histogramm)
    
    {time_Bar=Time[i];sum_pip_bay=0;
    sum_pip_sell=0;sum_pip=0;
    old_bay=0;old_sell=0;sum_tick=0;
    count_plus=0;count_minus=0;}
     
     //----  UP
    if(delta>=0)
    {if(delta>100)delta=1;
    sum_pip_bay = delta + old_bay;   
    old_bay=sum_pip_bay;
    count_plus++;}  
    
     //----  Down
    if(delta<0)
    { sum_pip_sell = delta+old_sell;
     old_sell=sum_pip_sell;
    count_minus++;}
          
    //---   1  2
        sum_tick=count_plus+count_minus;
        K1_Pl=count_plus/sum_tick;
        K1_Min=count_minus/sum_tick;
        
        sum_pip=sum_pip_bay+MathAbs(sum_pip_sell);
        K2_Pl=sum_pip_bay/sum_pip;
        K2_Min=MathAbs(sum_pip_sell)/sum_pip;
     
      //---Histogramm    
  
      if (MA1[i+1]>=0 && MA1[i+1]!=EMPTY_VALUE){TP_UP[k]=MA1[i+1];}else{if (MA1[i+1]!=EMPTY_VALUE)TP_UPMin[k]=MA1[i+1];}
      if (MA2[i+1]<=0 && MA2[i+1]!=EMPTY_VALUE){TP_DN[k]=MA2[i+1];}else{if (MA2[i+1]!=EMPTY_VALUE)TP_DNPl[k]=MA2[i+1];} 
      if(k>=Bar_Hist)k=0;
        
    MA11=iMA(NULL,0,13,0,1,4,0);
    MA22=iMA(NULL,0,34,0,1,4,0);
    MA33=iMA(NULL,0,89,0,1,4,0);  
   
     if(MA11>MA22&&MA11>MA33)text="UP";
     if(MA11<MA22&&MA11<MA33)text="DN";
     if((MA11<MA22&&MA11>MA33)||(MA11>MA22&&MA11<MA33))text="FL";
    
     //---Srednie  
  string Volum,Progn="Prognoz",Srednee_K1_Pl,Srednee_K2_Pl,Srednee_K1_Min,Srednee_K2_Min; 
      Vol[i]=Volume[i];
      VMA1[i]=iMAOnArray(Vol,0,8,0,0,0); 
      VMA2[i]=iMAOnArray(Vol,0,21,0,0,0); 
      VMA3[i]=iMAOnArray(Vol,0,89,0,0,0);
         
   //-----Tick & Pips UP or DN   
           
   if (VMA1[i] > VMA2[i] && VMA1[i] > VMA3[i])Volum="Rost_Volume";  
   if (VMA1[i] < VMA2[i] && VMA1[i] > VMA3[i])Volum="Snigenie_Volume";
   if (VMA1[i] < VMA2[i] && VMA1[i] < VMA3[i])Volum="Spad_Volume";
   if (VMA1[i] > VMA2[i] && VMA1[i] < VMA3[i])Volum="Povyshenie_Volume"; 
   //----
    old_price=price; 

//------
string trend; 
 if (maxArr(MA1)>MathAbs(minArr(MA2))){trend="DN_Trend";}else{trend="UP_Trend";}
//------

 if(NewBar()){k++;barz++;
 
 MA1[i] = -(1.6816 * count_plus - sum_pip_bay - 2.861);
 MA2[i] =  1.6498 * count_minus - MathAbs(sum_pip_sell)-2.097;
 
 SMA[i] = MA1[i]+MA2[i];
 MA3[i] =iMAOnArray(SMA,0,5,0,0,0);
       
  if(Sredn(TP_UP)>=3.0){Label("DN_Arrow"+"_"+Low[i]+"_"+TimeToStr(Time[i]),Time[i+1],High[i+1],Red);}
  
  if(Sredn(TP_DN)>=2.5){Label("UP_Arrow"+"_"+Low[i]+"_"+TimeToStr(Time[i]),Time[i+1],Low[i+1],Blue);}
 
  }
 //---- 

     SetText0("S_UP","S_DN","UP","DN",Gray,10);
     SetText01("Ticks","Ticks",Gray,10);
     SetText02("Pips","Pips",Gray,10);
     SetText03("Max/Min","Max/Min",Gray,10);
     
     SetText1("UP_ticks","DOWN_tick", DoubleToStr(Sredn(TP_UP),2),DoubleToStr(Sredn(TP_DN),2),Red,Blue,12);
     SetText1_v("UP_ticks1","DOWN_tick1",DoubleToStr(SrOtklon(TP_UP),2),DoubleToStr(SrOtklon(TP_DN),2),Red,Blue,12);
     SetText11("UP_pips","DOWN_pips", DoubleToStr(Sredn(TP_UPMin),2),DoubleToStr(Sredn(TP_DNPl),2),Red,Blue,12);
     SetText11_v("UP_pips1","DOWN_pips1", DoubleToStr(SrOtklon(TP_UPMin),2),DoubleToStr(SrOtklon(TP_DNPl),2),Red,Blue,12);
     SetText111("UP_Hist_max","DOWN_Hist_max", DoubleToStr(maxArr(MA1),1),DoubleToStr(minArr(MA2),1),Red,Blue,12);
     SetText111_v("UP_Hist_max2","DOWN_Hist_max2", DoubleToStr(minArr(MA1),1),DoubleToStr(maxArr(MA2),1),Red,Blue,12);
     SetText2("trend", trend, Green,11); 
   }                    
 
  return(0);
}

//---- 

double Sredn(double ArrSr[])
{
double a=1,c,step=1/Bar_Hist;
for (int i=0;i<=Bar_Hist;i++)
{if (ArrSr[i]==0){a*=1;}else{a*=MathAbs(ArrSr[i]);}}
c=MathPow(a, step);
  return(c);
}
//-------------
double SrOtklon(double ArrSr[])
{
double koaf=Bar_Hist,summ,sredn,otklon; 

for (int i=0;i<=Bar_Hist;i++)
{summ+=MathAbs(ArrSr[i]);
sredn=summ/koaf;
otklon=MathAbs(ArrSr[i]-sredn)/koaf;}
  return(otklon);
}
//-------------
double maxArr(double ArrCount[])  //---    
{
int col=ArrayRange(ArrCount,0);
double Element;
for(int i=0; i<=col; i++)
{
if(ArrCount[i]==EMPTY_VALUE)continue;
if(i==0)Element = ArrCount[i];
if(i>0)
{if(Element<ArrCount[i])Element=ArrCount[i];}
}
return(Element);
}
//-------------
double minArr(double ArrCount[]) //---    
{
int col=ArrayRange(ArrCount,0);
double Element;
for(int i=0; i<=col; i++)
{
if(ArrCount[i]==EMPTY_VALUE)continue;
if(i==0)Element = ArrCount[i];
if(i>0)
{if(Element>ArrCount[i])Element=ArrCount[i];}
}
return(Element);
}
//-------------
void SetText0(string name, string name2, string text, string text2, color c, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1113);
  ObjectSet(name, OBJPROP_YDISTANCE, 10);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1177);
  ObjectSet(name2, OBJPROP_YDISTANCE, 10);    
  ObjectSetText(name2,text2,7,"Arial Black",c);
 }
 //-------------
 void SetText01(string name, string text, color c, int size)  
 {                                                                                     
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1050);
  ObjectSet(name, OBJPROP_YDISTANCE, 25);    
  ObjectSetText(name,text,7,"Arial Black",c);
 }
 //-------------
 void SetText02(string name, string text, color c, int size)  
 {                                                                                     
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1050);
  ObjectSet(name, OBJPROP_YDISTANCE, 40);    
  ObjectSetText(name,text,7,"Arial Black",c);
 }
 //-------------
 void SetText03(string name, string text, color c, int size)  
 {                                                                                     
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1050);
  ObjectSet(name, OBJPROP_YDISTANCE, 55);    
  ObjectSetText(name,text,7,"Arial Black",c);
 }
 //-------------
 void SetText1(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     

  ObjectSet(name, OBJPROP_XDISTANCE, 1095);
  ObjectSet(name, OBJPROP_YDISTANCE, 25);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1160);
  ObjectSet(name2, OBJPROP_YDISTANCE, 25);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
 //-------------
 void SetText1_v(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1125);
  ObjectSet(name, OBJPROP_YDISTANCE, 25);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1190);
  ObjectSet(name2, OBJPROP_YDISTANCE, 25);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
 //-------------
 void SetText11(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     

  ObjectSet(name, OBJPROP_XDISTANCE, 1095);
  ObjectSet(name, OBJPROP_YDISTANCE, 40);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1160);
  ObjectSet(name2, OBJPROP_YDISTANCE, 40);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
//-------------
 void SetText11_v(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1125);
  ObjectSet(name, OBJPROP_YDISTANCE, 40);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1190);
  ObjectSet(name2, OBJPROP_YDISTANCE, 40);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
//-------------
void SetText111(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1095);
  ObjectSet(name, OBJPROP_YDISTANCE, 55);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1160);
  ObjectSet(name2, OBJPROP_YDISTANCE, 55);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
 //-------------
 void SetText111_v(string name, string name2, string text, string text2, color c, color c2, int size) //--- 
 {                                                                                     //---   
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1125);
  ObjectSet(name, OBJPROP_YDISTANCE, 55);    
  ObjectSetText(name,text,7,"Arial Black",c);
  ObjectCreate(name2,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name2, OBJPROP_XDISTANCE, 1190);
  ObjectSet(name2, OBJPROP_YDISTANCE, 55);    
  ObjectSetText(name2,text2,7,"Arial Black",c2);
 }
 //-------------
 void SetText2(string name, string text, color c, int size)  
 {                                                                                     
  ObjectCreate(name,OBJ_LABEL,0,0,0,0,0);     
  ObjectSet(name, OBJPROP_XDISTANCE, 1120);
  ObjectSet(name, OBJPROP_YDISTANCE, 70);    
  ObjectSetText(name,text,7,"Arial Black",c);
 }
 //-------------
 void Label(string name,datetime t1, double p1, color c)
 {
  ObjectCreate(name,OBJ_ARROW,0,0,0,0,0);
  ObjectSet(name, OBJPROP_ARROWCODE , 158);
  ObjectSet(name, OBJPROP_TIME1 , t1);
  ObjectSet(name, OBJPROP_PRICE1, p1);
  ObjectSet(name, OBJPROP_COLOR, c);    
 }
 //-------------
bool NewBar()
{
   static datetime lastbar = 0;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}
  